#include "config.h"

Config::Config(QObject *parent) :
    QObject(parent)
{

}

Config::~Config()
{
    writeConfig();
}

void Config::readConfig()
{
    // Uncomment one of the following 2 lines, depending if the settings should be saved in a "ini" file or in the registry
    QSettings settings("drcute.ini", QSettings::IniFormat);
    //QSettings settings;

    settings.beginGroup("Network");
    ipAddress = settings.value("ipAddress", QString()).toString();
    port = settings.value("port", QString("1")).toInt();
    settings.endGroup();

    qDebug() << "IP adress:" << ipAddress;
    qDebug() << "Port:" << port;

    settings.beginGroup("User");
    uniqueId = settings.value("uniqueId", QString()).toString();
    settings.endGroup();

    if (uniqueId.isEmpty()) uniqueId = generateUniqueId();
}

void Config::writeConfig()
{
    // Uncomment one of the following 2 lines, depending if the settings should be saved in a "ini" file or in the registry
    QSettings settings("drcute.ini", QSettings::IniFormat);
    //QSettings settings;

    settings.beginGroup("Network");
    settings.setValue("ipAddress", ipAddress);
    settings.setValue("port", port);
    settings.endGroup();

    settings.beginGroup("User");
    settings.setValue("uniqueId", uniqueId);
    settings.endGroup();
}

QString Config::generateUniqueId()
{
    // Number of seconds that have passed since 1970-01-01T00:00:00, expressed in HEX
    uint t = QDateTime::currentDateTime().toTime_t();
    QString s = QString::number(t, 16);
    qDebug() << "Generating a new unique ID based on time and date:" << s;
    return s;
}

