#ifndef CONFIG_H
#define CONFIG_H

#include <QObject>
#include <QSettings>
#include <QDebug>
#include <QDateTime>

class Config : public QObject
{
    Q_OBJECT

public:
    Config(QObject *parent = 0);
    ~Config();

    int getPort() { return port; }
    QString getIpAddress() { return ipAddress; }
    QString getUniqueId() { return uniqueId; }

public slots:
    void setIpAddress(const QString &msg) {
        qDebug() << "IP adress:" << msg;
        ipAddress = msg;
        writeConfig();
    }

    void setPort(const QString &msg) {
        qDebug() << "Port:" << msg;
        port = msg.toInt();
        writeConfig();
    }

    void readConfig();
    void writeConfig();

private:
    QString generateUniqueId();
    QString ipAddress;
    int port;
    QString userName;
    QString uniqueId;
};

#endif // CONFIG_H
