import QtQuick 1.0

//Rectangle {
Item {
    id: menuitem
    signal clicked
    signal sendmessage(string msg)
    signal headerClicked
    signal itemClicked

    property bool isHeader: false
    property string hPosition: "Left"
    property string vPosition: "Bottom"
    property int iconsizeOpen: isHeader ? largeiconsize : smalliconsize
    property int iconsizeClosed: smalliconsize
    property int iconsize: smalliconsize

    property int parentWidth: parent.width
    property string label
    property string label2
    property string label3
    property string parentLabel
    property string name
    property string message: name
    property string iconFilename: "qrc:/images/" + name + ".png"

    property string hoveredColor: isHeader ? backgroundColor : hoveredItemColor
    property bool menuFolded: false
    property int largestTextWidth: Math.max(itemText.width, Math.max(itemText2.width, itemText3.width))
    width: menuFolded ? (globalSpacing + iconsize) : (globalSpacing * 2 + iconsize + largestTextWidth + globalRadius)

    height: iconsize
    state: "open"

//    Binding {
//        target: menuitem
//        property: menuFolded
//        value: parent.folded
//    }

//    Binding {
//        target: menuitem
//        property: visible
////        value: (label != "") && ((!isHeader && parent.itemsVisible) || (isHeader && parent.headerVisible))
//        value: true
//    }



    Rectangle {
        id: bkgd
        color: backgroundColor
        x: globalSpacing * 2 + iconsize
        width: menuitem.width - x
        height: iconsize
    }


    Image {
        id: iconImage
        height: iconsize
        width: height
        x: ((hPosition == "Left") || !isHeader) ? globalSpacing : parentWidth - iconsize - globalSpacing
        y: 0
        source: parent.iconFilename
    }

    Text {
        id: itemText
        x: ((hPosition == "Left") || !isHeader) ? iconImage.width + globalSpacing * 3 : globalSpacing * 2
        y: iconImage.y + iconImage.height - itemText.height
        visible: !menuFolded //(width > 0)
        color: textColor
        font.pointSize: isHeader ? largeFontSize : smallFontSize
        text: qsTr(label)
    }

    Text {
        id: itemText2
        x: (hPosition == "Left") ? itemText.x - 2*menuitem.width : itemText.x + 2*menuitem.width
        y: itemText.y - itemText2.height - globalSpacing
        visible: (isHeader && (iconsize == largeiconsize))
        color: backgroundColor
        font.pointSize: smallFontSize
        text: qsTr(label2)
    }

    Text {
        id: itemText3
        x: (hPosition == "Left") ? itemText.x - 2*menuitem.width : itemText.x + 2*menuitem.width
        y: itemText2.y - itemText3.height - globalSpacing
        visible: (isHeader && (iconsize == largeiconsize))
        color: backgroundColor
        font.pointSize: smallFontSize
        text: qsTr(label3)
    }

    MouseArea
    {
        id: mouseArea
        anchors.fill: parent
        hoverEnabled: true
        onClicked: {
            if (isHeader)  menuitem.headerClicked();
            if (!isHeader) {
                menuitem.itemClicked();
                menuitem.sendmessage(menuitem.message);
            }
        }
    }

    states: [
        State {
            name: "hovered"
            when: mouseArea.containsMouse
            PropertyChanges { target: menuitem; iconsize: iconsizeOpen }
            PropertyChanges { target: itemText; color: hoveredTextColor}
            PropertyChanges { target: itemText2; x: itemText.x}
            PropertyChanges { target: itemText3; x: itemText.x}
            PropertyChanges { target: itemText2; color: textColor}
            PropertyChanges { target: itemText3; color: textColor}
            PropertyChanges { target: bkgd; color: hoveredColor}
        },
        State {
            name: "open"
            PropertyChanges { target: menuitem; x: 0 }
        },
        State {
            name: "folded"
            PropertyChanges { target: itemText; visible: false }
            PropertyChanges { target: menuitem; width: smalliconsize }
            PropertyChanges { target: menuitem; height: smalliconsize}
            PropertyChanges { target: iconImage; width: smalliconsize }
            PropertyChanges { target: iconImage; height: smalliconsize }
        }

    ]

    transitions: [
        Transition {
            from: "hovered"
            NumberAnimation { properties: "iconsize, x"; easing.type: Easing.OutBack; duration: 1000 }
            ColorAnimation { properties: "color"; easing.type: Easing.OutBack; duration: 1000 }
        },
        Transition {
            to: "hovered"
            ColorAnimation { properties: "color"; easing.type: Easing.OutBack; duration: 200 }
            NumberAnimation { properties: "iconsize"; easing.type: Easing.OutBack; duration: 200 }
            NumberAnimation { properties: "x"; easing.type: Easing.OutQuad; duration: 1000 }
        }
    ]
}

