#include <QtCore/QCoreApplication>
#include <QDebug>
#include "server.h"
#include "sessionmanager.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);
    qDebug() << "Starting MrHyde!\n";

    // Those definitions are required to store and retrieve the application settings
    QCoreApplication::setOrganizationName("0x4e84");
    QCoreApplication::setApplicationName("MrHyde");

    QStringList cmdline_args = QCoreApplication::arguments();

    // Taking into account the command line parameters (program options or "switches")
    bool localMode = true;
    bool prepareMode = false;
    foreach (QString arg, cmdline_args) {
        if (arg == QString("-remote")) localMode = false;
        if (arg == QString("-local")) localMode = true;
        if (arg == QString("-prepare")) prepareMode = true;
    }

    // The objects we need for the program
    Server server(localMode);

    if (localMode) qDebug() << "Local mode";
    if (prepareMode) server.prepare();

    return a.exec();
}

