#ifndef SERVER_H
#define SERVER_H

#include <QObject>
#include "servernode.h"
#include "sql.h"
#include "config.h"

QT_BEGIN_NAMESPACE
class QTimer;
class QTcpServer;
class QNetworkSession;
class QTextStream;
QT_END_NAMESPACE


class Server : public QObject
{
    Q_OBJECT
public:
    explicit Server(bool isLocal, QObject *parent = 0);
    bool isLocalMode;
    void prepare();

private slots:
    void sessionOpened();
    void acceptConnection();
    void sendMessage(const QString &msg);

private:
    QTimer *timer;
    QTcpServer *tcpServer;
    QNetworkSession *networkSession;
    Sql sql;
};

#endif // SERVER_H
