#ifndef SERVERNODE_H
#define SERVERNODE_H

#include <QObject>
#include <QTcpSocket>
#include <QtGui/QImage>
#include <QBuffer>
#include <QStringList>
#include "sql.h"


QT_BEGIN_NAMESPACE
//class QTcpSocket;
class QTextStream;
class QDataStream;
QT_END_NAMESPACE

class ServerNode : public QObject
{
    Q_OBJECT
public:
    explicit ServerNode(QObject *parent, QTcpSocket *socket, Sql *db);

signals:
//    void messageReceived(const QString &msg);

public slots:
    void readString();
    void readMessage();
    void sendString(const QString &msg);
    void sendStringList(const QStringList &msgList);
    void sendImage(const QImage &img);
    void sendDefaultImage();


private:
    void interpretCommandAndAnswer(const QString uniqueId, const QString &cmd, const QStringList &msgList);
    QTcpSocket *tcpSocket;
    Sql *sql;

};

#endif // SERVERNODE_H
