#ifndef SQL_H
#define SQL_H

#include <QObject>
#include <QtSql>

QT_BEGIN_NAMESPACE
class QSqlTableModel;
class QSqlDatabase;
class QSqlError;
class QSqlQuery;
QT_END_NAMESPACE

class Sql : public QObject
{
    Q_OBJECT

public:
    Sql(QObject *parent = 0);
    void doQuery(QString select, QString from);
    bool isOpen() { return dbIsOpen; }
    int getDoctorCount() { return doctorCount; }
    int getPatientCount() { return patientCount; }

    void createStructure();
    QStringList listDoctors();
    QStringList listPatients();
    void addDoctor(QString employeeId, QString title, QString firstName, QString lastName);
    void addPatient(QString socialSecurityId, QString title, QString firstName, QString lastName);
    void deleteDoctor(QString employeeId);
    void deletePatient(QString socialSecurityId);

signals:

public slots:

private:
    bool dbIsOpen;
    QSqlTableModel *model;
    QString dbName;
    QString dbFilename;
    int doctorCount;
    int patientCount;
};

#endif // SQL_H
